/*
Attribution-NonCommercial-ShareAlike 3.0 (http://creativecommons.org/licenses/by-nc-sa/3.0/us/) + Windfinder Additions

You are free:
* to share - to copy, distribute, display, and perform the work
* to remix - to make derivative works (add new features, make improvements, fix bugs)

Under the following conditions:

* Attribution: You must attribute the work in the manner specified by the author or licensor (but not in any way that suggests that they endorse you or your use of the work).
* Noncommercial: You may not use this work for commercial purposes.
* Share Alike: If you alter, transform, or build upon this work, you may distribute the resulting work only under the same or similar license to this one.

* For any reuse or distribution, you must make clear to others the license terms of this work. The best way to do this is with a link to Windfinder.com.
* Any of the above conditions can be waived if you get permission from the copyright holder.
* Apart from the remix rights granted under this license, nothing in this license impairs or restricts the author's moral rights.

Windfinder Addtions:
* Respect trademark rights: You may not alter the Windfinder logo or remove it from the software.
* Respect data source: You may not change the download source of the weather data that is displayed in the software. The weather data that is displayed in the software has to originate from Windfinder.com. 
* Display limitations: You may not display more than three weather parameters (e.g. wind speed, wind direction, air temperature) in the software 
* No advertising, logos or ad banners from third parties: You may not display advertising,logos or ad banners from companies other than Windfinder.com

*/

/*
these are functions used in both front and settings
*/

function getLocalizedString (key) {
	try {
		var ret = localizedStrings[key];
		if (ret === undefined)
			ret = key;
		return ret;
	} catch (ex) {}
	//alert(key);
	return key;
}
function knots2myunit(myvalue) {
	var myUnit=System.Gadget.Settings.read("myWindUnit");
	switch(myUnit)  {
		case 'bft':
			var bft=0;
			if (myvalue>=0.6) bft = 1;if (myvalue>=3) bft = 2;if (myvalue>=7) bft = 3;if (myvalue>=11) bft = 4;if (myvalue>=16) bft = 5;
			if (myvalue>=21) bft = 6;if (myvalue>=27) bft = 7;if (myvalue>=33) bft = 8;if (myvalue>=40) bft = 9;if (myvalue>=47) bft = 10;if (myvalue>=55) bft = 11;if (myvalue>=64) bft = 12;
			myvalue=bft;
			break;
		case 'ms':
			myvalue=0.514444*myvalue;
			break;
		case 'kmh':
			myvalue=3.6*0.514444*myvalue;
			break;
		default :
			break;
	}
	return myvalue;
}
function myunit2knots(myvalue) {
	var myUnit=System.Gadget.Settings.read("myWindUnit");
	switch(myUnit)  {
		case 'bft':
			var bft=0;
			if (myvalue>=1) bft = 0.6;if (myvalue>=2) bft = 3;if (myvalue>=3) bft = 7;if (myvalue>=4) bft = 11;if (myvalue>=5) bft = 16;
			if (myvalue>=6) bft = 21;if (myvalue>=7) bft = 27;if (myvalue>=8) bft = 33;if (myvalue>=9) bft = 40;if (myvalue>=10) bft = 47;if (myvalue>=11) bft = 55;if (myvalue>=12) bft = 64;
			myvalue=bft;
			break;
		case 'ms':
			myvalue=myvalue/0.514444;
			break;
		case 'kmh':
			myvalue=myvalue/(3.6*0.514444);
			break;
		default :
			break;
	}
	return myvalue;
}
function meters2feet(myvalue) {
	myvalue=Math.round(3.2808399*myvalue);
	return myvalue;
}
function feet2meters(myvalue) {
	myvalue=myvalue/3.2808399;
	return myvalue;
}
function celcius2farenheit(myvalue) {
	myvalue=32+(9*myvalue)/5;
	return myvalue; 
}
function farenheit2celcius(myvalue) {
	myvalue=5*(myvalue-32)/9;
	return myvalue; 
}

function writeToCache(filename, data) {
	var path = System.Gadget.path;
	
	var fs = new ActiveXObject("Scripting.FileSystemObject");  
	var newFile = fs.OpenTextFile(path + "\\cache\\" + filename, 2, true);  
   
     try {  
         newFile.Write(data);  
     }  
     finally {  
         newFile.Close();  
	}
}

function readFromCache(filename) {
	var path = System.Gadget.path;
	var data = "";
	
	var fs = new ActiveXObject("Scripting.FileSystemObject");  
    var fileHandle = fs.OpenTextFile(path + "\\cache\\" + filename, 1, -1);  
   
     try {  
         data = fileHandle.ReadAll();  
     }  
     finally {  
         fileHandle.Close();  
	}
	
	return data;
}

function fileExistsInCache(filename) {
	var path = System.Gadget.path;
		
	var fs = new ActiveXObject("Scripting.FileSystemObject");  
    return fs.FileExists(path + "\\cache\\" + filename);  

}

function buildDOM(xmlData) {
    
	xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
	xmlDoc.async=false;
	xmlDoc.loadXML(xmlData);
	
	return xmlDoc;
}

function isDOMParserAvailable() {
	rc = true;
	
	try {
		var test = new ActiveXObject("Microsoft.XMLDOM");
	}
	catch (e) {
		rc = false;
	}
	
	return rc;
}

function isFileObjectAvailable() {
	rc = true;
	
	try {
		var test = new ActiveXObject("Scripting.FileSystemObject");
	}
	catch (e) {
		rc = false;
	}
	
	return rc;
}

function updateAvailable(serverVersion) {
	var available = false;
	var currentVersionParts = System.Gadget.version.split(".");
	var serverVersionParts = serverVersion.split(".");
	
	var length = currentVersionParts.length;
	if (currentVersionParts.length > serverVersionParts.length) {
		var length = serverVersionParts.length;
	}
	
	var rc = 0;
	// check which version is more up-to-date
	// 1 for the current installed version
	// 2 for server version
	for(var i=0; i < length; i++) {	
		if(currentVersionParts[i] > serverVersionParts[i]) {
			rc = 1;
			break;
		}
		else if (serverVersionParts[i] > currentVersionParts[i]) {
			rc = 2;
			break;
		}	   
	}
	
	var returnValue = true ? rc == 2 : false;
	
	return returnValue;

}